// tutorial 15+ - adding new comments

var data = [
    {author: "Pete Hunt", text: "This is one comment..."},
    {author: "Jordan Walke", text: "This is *another* comment"}
];

var Comment = React.createClass({
    render: function() {
	var rawMarkup = marked(this.props.children.toString(), {sanitise: true});
	return (
	    <div className="comment">
	    <h2 className="commentAuthor">
	    {this.props.author}
	    </h2>
	    <span dangerouslySetInnerHTML={{__html: rawMarkup }} />
	    </div>
	);
    }

});

var CommentList = React.createClass({
    render: function() {
	var commentNodes = this.props.data.map(function(comment) {
	    return (
		<Comment author={comment.author}>
		{comment.text}
		</Comment>
	    );
	});
	return (
	    <div className="commentList">
	    {commentNodes}
	    </div>
	);
    }
});


var CommentForm = React.createClass({
    handleSubmit: function(e) {
	e.preventDefault();
	var author = React.findDOMNode(this.refs.author).value.trim();
	var text = React.findDOMNode(this.refs.text).value.trim();
	if (!text || !author) {
	    return;
	}
	console.log(author + " entered " + text);
	this.props.onCommentSubmit({author: author, text: text});
	React.findDOMNode(this.refs.author).value = '';
	React.findDOMNode(this.refs.text).value = '';
	return;
    },
    render: function() {
	return (
	    <form className="commentForm" onSubmit={this.handleSubmit}>
	    <input type="text" placeholder="Your name" ref="author" />
	    <input type="text" placeholder="Say something..." ref="text" />
	    <input type="submit" value="Post" />
	    </form>
	);
    }
});

var CommentBox = React.createClass({
    loadCommentsFromServer: function() {
	console.log("about to do Ajax call");
	$.ajax({
	    url: this.props.url,
	    dataType: 'json',
	    cache: false,
	    success: function(data) {
		// console.log("success handler called");
		this.setState({data: data});
	    }.bind(this),
	    error: function(xhr, status, err) {
		console.log("Something blew up");
		console.error(this.props.url, status, err.toString());
	    }.bind(this)
	});
    },
    handleCommentSubmit: function(comment) {
	console.log("CommentBox.handleCommentSubmit: " + comment.author +
	    ": " + comment.text);
	var comments = this.state.data;
	var newComments = comments.concat([comment]);
	this.setState({data: newComments});
	// TODO: submit to the server and refresh the list
	// I haven't added in the XHR POST here because I just have a dumb
	// fileserving webserver for this tutorial - it just does a
	// this.setState({data: data}) on successful response - in fact looks
	// identical to the XHR in loadCommentsFromServer(), except it's a POST,
	// and it passes a "data: comment" payload.
    },
    getInitialState: function() {
	return {data: []};
    },
    componentDidMount: function() {
	this.loadCommentsFromServer();
	setInterval(this.loadCommentsFromServer, this.props.pollInterval);
    },

    render: function() {
	return (
	    <div className="commentBox">
	    <h1>Comments</h1>
	    <CommentList data={this.state.data} />
	    <CommentForm onCommentSubmit={this.handleCommentSubmit} />
	    </div>
	);
    }
});
React.render(
    <CommentBox url="comments.json" pollInterval={2000}/>,
    document.getElementById('content')
);